#include <compiler.h>
#include <sys/param.h>
#include <unistd.h>
#include <errno.h>
#include <mintbind.h>

extern int __mint;

int
getloadavg (loadavg, nelem)
     double *loadavg;
     int nelem;
{
  long uptime, avenrun[3], r;
  int i;

  if (!__mint)
    {
      errno = EINVAL;
      return -1;
    }

  r = Suptime (&uptime, avenrun);
  if (r < 0)
    {
      errno = (int) -r;
      return -1;
    }

  for (i = 0; i < nelem && i < 3; i++)
    loadavg[i] = (double) avenrun[i] / FSCALE;

  return i;
}
